SystemOrganization addCategory: #'Magma seasideHelper'!

!WAApplicationEditor methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 22:52'!
visitMagmaLocationAttribute: anAttribute with: html

	| location |
	location := configuration valueForAttribute: anAttribute. 

	location ifNil: [ location := anAttribute defaultLocationFor: application ].
		
	html select 
		list: anAttribute options;
		selected: location class;
		beSubmitOnChange;
		labels: [ :ea | ea name ];
		callback: [ :item | 	(configuration valueAt: #location) class == item
			ifFalse: [ configuration takeValue: (item defaultFor: application) forAttribute: anAttribute. ]
 		];
		yourself.

	location renderOn: html  ! !

!MagmaCollection class methodsFor: '*magma seasidehelper' stamp: 'kph 12/8/2007 01:34'!
getVirtualRootIn: root
	
	"Get the view-root of this pov from an actual root"
	
	^  self subclassResponsibility! !

!MagmaCollection class methodsFor: '*magma seasidehelper' stamp: 'kph 12/8/2007 01:35'!
setVirtualRootIn: root to: anObject
	
	"Set the view-root of this pov"
	self subclassResponsibility.
	
	 ^ anObject! !

!MagmaCollection methodsFor: '*magma seasideHelper' stamp: 'kph 12/8/2007 01:37'!
firstRead: helper! !

!MagmaCollection methodsFor: '*magma seasideHelper' stamp: 'kph 12/8/2007 01:37'!
isCached

	^ false! !

IdentityDictionary subclass: #WADictionaryRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WADictionaryRoot commentStamp: 'kph 12/7/2007 23:12' prior: 0!
Note that WADictionaryRoot is a subclass of IdentityDictionary. Magma does not support subclasses of IdentityDictionary which add instance vars.!

!WADictionaryRoot class methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 00:57'!
getVirtualRootIn: root
	
	"Get the view-root of this pov from an actual root"
	
	^  root! !

!WADictionaryRoot class methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:18'!
setVirtualRootIn: root to: anObject
	
	"Set the view-root of this pov"
	self subclassResponsibility.
	
	 ^ anObject! !

!WADictionaryRoot methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:36'!
firstRead: helper

 ! !

!WADictionaryRoot methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:35'!
isCached

	^ true! !

WAConfigurationAttribute subclass: #WAMagmaLocationAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 10:00'!
accept: aVisitor with: anObject

	^ aVisitor visitMagmaLocationAttribute: self with: anObject! !

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'kph 12/7/2007 22:52'!
defaultLocationFor: app

	^ MagmaLocalLocation defaultFor: app! !

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 11:55'!
options

	^ MagmaLocation allSubclasses! !

!MagmaRemoteLocation methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 22:04'!
renderContentOn: html

	html tableRow: [  
		html tableData id: 'label'; with: 'host'.
		html tableData: [ html textInput on: #host of: self ]
	].
					
	html tableRow: [  
		html tableData id: 'label'; with: 'port'.
		html tableData: [ html textInput value: self port;
							callback: [:v | self port: v asNumber] 
		].
	].
		 ! !

WASessionHelper subclass: #WAMagma
	instanceVariableNames: 'seasideSession magmaSession root views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMagma commentStamp: 'kph 12/7/2007 23:40' prior: 0!
The aim of this version of the Magma-seaside integration framework is to learn some lessons from projects already using Magma in order to satisfy the following goals.

The overriding goal was to make the tutorial very easy, so as to blow away the competition!!

====
1. Simplify configuration. 
2. Ease combining Magma with other seaside technologies, to which end we do not subclass WASession.
3. Enable a choice of session management options such as shared or pooled sessions again orthogonal to the domain, or other settings.
4a. Facilitiate modularization, such that a Magma user-accounts module can be marketed as a standalone package, combinable with other modules, such as a pier module, or a shopping-cart module.
4b. Similarly, facilitate combination of projects having separate databases into one, e.g. gjallar & pier.
5. Simplify use and initialization, not just of the root object but also sub-branches of the database
   which are used by different application-modules or application sub-domains. 
6. Facilitate server managed preferences and data, multi-server operation, and load sharing schemes.

====

1.  The configuration provides a selector for the database helper class which provides session management. You can provide your own scheme by subclassing any of the WAMagma helper classes.

The local database directory, is initially set to 'Automatic' which will save the data in 'magma-todo' directory for the 'todo' entry point. This ensures that by default no configuration is required while at the same time separate applications will not step on each others databases files.

2. In order for Magma to be used alongside other frameworks which have specialized session classes such as Glorp, the configuration of Magma is now orthogonal to the choice of WASession. You may subclass WASession if you need to in order to support your application domain, but it is not necessary to do so in order to use Magma, or to store session state. Session state can be stored using the WASession-#properties dictionary.

This is accomplished through the WASessionHelper framework which is part of Seaside28Jetsam. Magma is supported by one such helper and the chosen Magma helper is accessed via WASession-#magma.

3. Magma helpers provide session management.
	single	- WAMagma
	shared	- WAMagmaShared
	pooled	- WAMagmaPooled
	mock	- WAMockMagma
	
4. As a stratgic design decision we plan to enable sub-domain-models to be accessed in the seaside application domain irresepective of their place in the actual database structure.
Explicitly from seaside we always use the following idiom to obtain our models from the database, the model classes themselves know where in the database structure they are to be found.

mySession magma rootAs: MyModelClass.

To do this we do not generally use general purpose object as our model classes. Instead we define specialized model classes so that they know where in the database they are located, and importantly they know how to initialize themselves.

This scheme allows several applications or sub-domains to be layered upon a single database. Each model class can nominate the position of its own root object (see class methods #getVirtualRootIn: #initializeVirtualRootIn: etc) in the main database. This also allows the database to be re-organised by changing model classes only. The seaside application domain view's are decoupled from the macro-structure of the database via the #rootAs: idiom.

Your custom accessors and queries onto the model for your domain are provided by subclassing typical model objects.
	typically, WADictionaryRoot, Object or MagmaCollection.

For example, to define an application specific model "ToDoList" for your database, subclass WADatabaseRoot (which is an IdentityDictionary) and define your custom accessors on that class e.g.

ToDoList-#items
^ self at: #items 

If the value of items is an instance of a subclass of MagmaCollection called TodoListItemsCollection then you can define your custom item based queries on your own subclass, encouraging typical object-oriented encapsulation.

itemsForUser: name 
	self where: [ :each | each usersName equals: name ]

On your domain objects or components, access your database like so:

MyComponent-todoListDatabase
	^ self session magma rootAs: ToDoList

and...

MyComponent-todoListItems
	^ self todoListDatabase items
	
However for a sub-domain or module model you can also do.

MyComponent-todoListItems
	^ self session magma rootAs: TodoListItemsCollection

Since the TodoListItemsCollection itself also knows where in the database it is located.	

5. Initialization is performed automatically as far as is possible.

When using the standard accessor idiom: 'self session magma rootAs: MyModel'. If this is performed and the database does not exist, or has no root class, then, the root will automatically be initialized according to the #actualRootClass nominated by MyModel. Making databases auto-initializing. If the model object for MyModel is not present in the database, then it will also be initialized automatically.

The initialized root or model-objects are configured, and indexes added if needed, in their respective #initialize methods.

If a model is retrieved that is not of the correct class, #rootAs: attempts to mutate the instance into the desired class, thus providing some automatic schema migration at the module level.

6. Server managed preferences

This is provided by an optional module. It allows a seaside server application to pick up settings and preferences from the magma server. Whenever a new seaside session is started, on the first time only, the root object's #firstRead: method is called. If it then calls 'helper rootAs: WAServerManagedPreferences'.

WAServerManagedPreferences is implemented as a module, being as self contained as possible. It assumes the root object of the database is a dictionary (if not it will need to be reconfigured appropriately).

This module, when #firstRead:, checks its #expiry time, and if it has expired, it loads the current application's preferences with the values that it contains. The values are each sent #value before being written.

This would allow #location to return a version of MagmaRemoteLocation which when sent #value, evaluates picking a remove server based upon the client's itentity


Direct usage:
WAMagma helper may be used with Seaside, or directly. Configuration is per-seaside application e.g.

(WAMagma forApp: 'todo') location.
(WAMagma forApp: 'todo') readStrategyClass.
(WAMagma forApp: 'todo') areMaterializationNotificationsEnabled.
(WAMagma forApp: 'todo') commit: [].
 


!

!WAMagma class methodsFor: 'magma preferences' stamp: 'kph 10/28/2007 23:50'!
debugProxies: aBoolean

	MagmaPreferences debugProxies: aBoolean! !

!WAMagma class methodsFor: 'public factory methods' stamp: 'kph 10/28/2007 21:28'!
factory

	^ WACurrentSession value magma class! !

!WAMagma class methodsFor: 'public factory methods' stamp: 'kph 12/8/2007 00:15'!
forApp: appName 

	"this gets you DIRECT command line access to the helper outside of browser
	with the configuration of the named application"
	
	^ (WASession forApp: appName) magma 
	 ! !

!WAMagma class methodsFor: 'helper protocol' stamp: 'kph 12/8/2007 00:05'!
helperKey

	^ #magma! !

!WAMagma class methodsFor: 'helper protocol' stamp: 'kph 10/27/2007 05:40'!
isEnabledFor: app

	^ (app preferenceAt: #magmaHelperClass)  = self ! !

!WAMagma class methodsFor: 'public factory methods' stamp: 'kph 10/28/2007 21:42'!
newMagmaCollection
	"usage: WAMagma factory newNewMagmaCollection"
	^ MagmaCollection new! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 00:40'!
abort

	self magmaSession abort! !

!WAMagma methodsFor: 'helper protocol' stamp: 'kph 11/16/2007 20:02'!
addHelperTo: helpers
	seasideSession := helpers session.
	super addHelperTo: helpers.
		! !

!WAMagma methodsFor: 'backup' stamp: 'kph 10/28/2007 23:31'!
backupDatabaseTo: aDirectory
	" Backup the database to aDirectory, and wait until the backup process ends. "

	| semaphoreWaitingForEndOfBackupProcess |
	semaphoreWaitingForEndOfBackupProcess := (self magmaSession repositoryController fullBackupTo: aDirectory).
	semaphoreWaitingForEndOfBackupProcess wait! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 00:39'!
begin

	self magmaSession begin! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/28/2007 23:29'!
canStubOut: anObject

	^ self magmaSession canStubOut: anObject
! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 00:46'!
commit: aBlock

	"we wrap the call to commit so that 'direct' users can make use of the factory"
	
	^ self privateDuring: [ self magmaSession commit: aBlock ]! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 01:09'!
defaultRootClass

	^ WADictionaryRoot! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 12/8/2007 01:58'!
info

	^ seasideSession application preferenceAt: #info! !

!WAMagma methodsFor: 'ops' stamp: 'kph 11/16/2007 20:51'!
initialize
	views := IdentityDictionary new.
! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/29/2007 01:52'!
location

	^ seasideSession application preferenceAt: #location! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/28/2007 21:28'!
magmaHelperClass

 ^ self application preferenceAt: #magmaHelperClass! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 00:16'!
magmaSession

	^ magmaSession ifNil: [ magmaSession := self obtainMagmaSession ]! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 12/7/2007 23:50'!
obtainMagmaSession
 
	magmaSession := self location newSessionAs: 'seaside'.

	magmaSession preferences signalProxyMaterializations: (self signalProxyMaterializations).
	
	self updateReadStrategy.

	^ magmaSession! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 00:53'!
onFirstRead

	self rootAs: WAServerManagedPreferences. ! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 00:20'!
possiblyCommit: aBlock
	"This is a variant of #commit: in which we do #begin
	and then #commit if still #inTransaction. This makes
	it possible for code inside the block to abort and perform
	its own non-nested commits instead. We only commit at
	the end if we are still in a transaction.
 "

	^ self privateDuring: [ 
		| result |
		self magmaSession begin.
		result := aBlock value.
		self magmaSession inTransaction ifTrue: [self magmaSession commit].
		result]! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 05:23'!
postProcessRequest: aRequest returned: aResponse

	self beep.! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 00:19'!
privateDuring: aBlock

	"we wrap the block as an aid so that 'direct' users can make use of the factory"
	
	^ WACurrentSession use: seasideSession during: [ aBlock value ]! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 01:02'!
privateInitializeRootTo: aValue

	self location isLocal ifFalse: [ ^ self error: ' cannot create a non local database' ].
	 
	self privateDuring: [ 
		MagmaRepositoryController
			create: self location
			root: aValue
	].

	^ aValue! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/28/2007 21:26'!
readStrategyClass

 ^ self application preferenceAt: #readStrategy! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 05:24'!
responseForRequest: aRequest with: aBlock

	| result |
	 
	^ [ "before"   result := aBlock value. "after". result ]
! !

!WAMagma methodsFor: 'ops' stamp: 'kph 12/8/2007 01:27'!
rootAs: interfaceClass

	| viewRoot |
	"
	It presents a root one of many possible views from the point of view of this application, as defined by the given interfaceClass 
	
	Views are sub-sections of the database, such that one database can be the combination of databases from 
	several separate applications combined.  
	
	When we obtain a root, or view-root, If it is nil we initialize it to be an instance of the nominated class.
	
	If we find that the database has no real root object we initialize it to #defaultRootClass.
	 
	If we find that the root class is not the class we anticipated we coerce it to given class  
	(of course this will only work if the two are similar)
	"
	
	"hit our cache first"
	views at: interfaceClass ifPresent: [ :v | ^ v ].
	
	"obtain the actual database root, if the database does not exist create it using the nominated root class" 
			
	root ifNil: [
		
		root := [ self magmaSession root ] on: MagmaEnvironmentError do: [ :ex | self privateInitializeRootTo: self defaultRootClass new ].
		"we are at the first read of the actual db root"
		self onFirstRead.
	].

	root ifNil: [ self error: 'database is empty, or has yet to be configured' ].

	"if we were handed nil as the interfaceClass return the actual database root"
	interfaceClass ifNil: [ ^ root ].

	"map the actual root to the root of this view"
	viewRoot := interfaceClass getVirtualRootIn: root.

	viewRoot == root ifTrue: [ ^ viewRoot ].
	
	"if it doesnt exist initialize it"
	viewRoot ifNil: [ self commit: [ viewRoot := interfaceClass setVirtualRootIn: root to: interfaceClass new ] ] .
	
	"if it is of the wrong class attempt to migrate it"
	(viewRoot class = interfaceClass) ifFalse: [ 
			self commit: [ viewRoot := interfaceClass setVirtualRootIn: root to:  (interfaceClass adoptInstance: viewRoot from: viewRoot class) ] ]  .
	
	viewRoot firstRead: self.
	
	viewRoot isCached ifTrue: [ views at: interfaceClass put: viewRoot ].

	^ viewRoot
	! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 12:04'!
seasideSession

	^ seasideSession! !

!WAMagma methodsFor: 'ops' stamp: 'kph 11/16/2007 20:51'!
setUp: helpers
	 ! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/29/2007 03:21'!
signalProxyMaterializations

 ^ seasideSession application preferenceAt: #signalProxyMaterializations! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/28/2007 23:37'!
stubOut: anObject

	^ self magmaSession stubOut: anObject
! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 00:42'!
submit: serverRequest

	^ self magmaSession submit: serverRequest 
! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 01:49'!
updateReadStrategy! !

WAMagma subclass: #WAMockMagma
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!Object methodsFor: '*magma seasideHelper' stamp: 'kph 10/29/2007 01:27'!
equals: a
	"this is liisted as an operator in MaClause, for use in Magma queries, duplicated here for
	MockMagmaCollection support"
	
	^ self = a! !

Object subclass: #WAServerManagedPreferences
	instanceVariableNames: 'preferences expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAServerManagedPreferences commentStamp: 'kph 12/8/2007 01:52' prior: 0!
WAServerManagedPreferences is intended to allow a number of seaside servers to be given some of their applications preferences from a central persistent store.

WAServerManagedPreferences is automatically read on a sessions first read of a magma database, if the expire time has been reached then any persisted preferences are read and the current application's preferences are updated.


!

!WAServerManagedPreferences class methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:19'!
getVirtualRootIn: root
	
	"Get the view-root of this pov"
	
	^  root at: #prefs ifAbsent: nil! !

!WAServerManagedPreferences class methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:39'!
setVirtualRootIn: root to: aServerManagementPreferences
	
	"Set the view-root of this pov"
	
	^ root at: #prefs put: aServerManagementPreferences! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:17'!
expiry

	^ expiry! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:50'!
expiry: dateAndTime

	expiry := dateAndTime! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:50'!
firstRead: helper

	expiry ifNil: [ ^ self ].
	
	expiry < DateAndTime now ifTrue: [ self update: helper ]! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 01:49'!
initialize
	expiry := nil.
	preferences := IdentityDictionary new.! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 12:27'!
isCached

	^ false! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:18'!
preferences

	^ preferences! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 12:43'!
update: helper

	helper seasideSession application in: [ :app |
		self preferences keysAndValuesDo: [ :k :v | app preferenceAt: k put: v value ]
	]! !

!MagmaLocation class methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 22:24'!
defaultFor: seasideApp

	^ self default! !

!MagmaLocation methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 22:46'!
isValid

	^ true! !

!MagmaLocation methodsFor: '*magma seasidehelper' stamp: 'kph 9/9/2006 03:21'!
newSessionAs: userName

 ^ self newSession connectAs: userName; yourself! !

!MagmaLocation methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 21:41'!
renderContentOn: html
	
	self subclassResponsibility! !

!MagmaLocation methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 21:41'!
renderOn: html

	 
	html div id: 'location'; with: [
		html table: [
			self renderContentOn: html
		]
	].
! !

WASystemConfiguration subclass: #WAMagmaConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2007 14:34'!
ancestors

	^ #() "Array with: (WARenderLoopConfiguration new)"! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 02:02'!
attributeAutoCommit

	^ WABooleanAttribute key: #autoCommit group: #magma! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 04:54'!
attributeLocation

	^ WAMagmaLocationAttribute key: #location group: #magma! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 04:54'!
attributeReadStrategy

	^ (WAListAttribute key: #readStrategy group: #magma)
		options: self readStrategyClasses; 
		yourself
		! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 04:55'!
attributeSignalProxyMaterializations

	^ WABooleanAttribute key: #signalProxyMaterializations group: #magma
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 04:56'!
attributes
	^ (self class selectors
		select: [ :each | each ~= #attributes
			and: [ each beginsWith: #attribute ] ])
		collect: [ :each | self perform: each ]! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 02:02'!
autoCommit

	^ true! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/7/2007 22:51'!
location

	^  nil! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:10'!
readStrategy 

^ WAMagmaReadStrategyDefault 
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:12'!
readStrategyClasses 

^ WAMagmaReadStrategyDefault withAllSubclasses 
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:35'!
repositoryPath

	^ 'store'
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:24'!
sessionClass

	^ WAMagmaSession! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:12'!
signalProxyMaterializations 

	^ false! !

!WASession methodsFor: '*magma seasidehelper' stamp: 'kph 10/29/2007 01:43'!
magma
	^ self helpers at: #magma ifAbsent: [ self error: 'Magma helper not selected in application configuration' ]! !

!MagmaLocalLocation class methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 22:29'!
defaultFor: seasideApp

	^ self path: ('magma-', seasideApp name)! !

!MagmaLocalLocation methodsFor: '*magma seasidehelper' stamp: 'cmm 7/1/2007 13:52'!
commitLogDirectory
	^ FileDirectory on: (self directory fullNameFor: MaRecoveryManager commitLogDirectoryName)! !

!MagmaLocalLocation methodsFor: '*magma seasidehelper' stamp: 'cmm 7/16/2007 22:12'!
delete
	"Delete the files at my location."
	self isRepository 
		ifTrue: 
			[ MagmaDeleteWarning signal: 'The Magma database at ' , self pathName , ' is about to be deleted.'.
			self directory deleteLocalFiles.
			self commitLogDirectory deleteLocalFiles ]
		ifFalse: 
			[ MagmaNotification signal: 'There is no Magma repository at ' , self pathName ]! !

!MagmaLocalLocation methodsFor: '*magma seasidehelper' stamp: 'cmm 4/20/2007 16:31'!
isRepository
	^ self directory exists and: [ self directory fileExists: MaObjectFiler objectsPhysicalFilename ]! !

!MagmaLocalLocation methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 22:46'!
isValid

	^ path notNil! !

!MagmaLocalLocation methodsFor: '*magma seasidehelper' stamp: 'kph 12/7/2007 21:42'!
renderContentOn: html
 
	html tableRow: [  
			html tableData id: 'label'; with: 'path:'.
			html tableData: [ html textInput on: #path of: self ]
	]
			 ! !

!MagmaCollectionReader methodsFor: '*Magma seasideHelper' stamp: 'kph 10/28/2007 21:35'!
where: aBlock orSelect: bBlock
	 
	^ self where: aBlock! !
